--- /etc/inc/dyndns.class.original	2022-06-16 10:07:32.721796000 -0400
+++ /etc/inc/dyndns.class	2022-06-16 10:19:11.814966000 -0400
@@ -1397,6 +1397,7 @@
 					}
 					curl_setopt($ch, CURLOPT_URL, $server . $port);
 					curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
+
 					break;
 				case 'digitalocean':
 				case 'digitalocean-v6':
@@ -1406,11 +1407,27 @@
 					$url = $server . $this->_dnsDomain . '/records';
 					curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer {$this->_dnsPass}"));
 					curl_setopt($ch, CURLOPT_URL, $url);
-					$output = json_decode(curl_exec($ch));
+					curl_setopt($ch, CURLOPT_HEADER, true);
+					$allout=curl_exec($ch);
+					preg_match_all("/^Set-cookie: (.*?);/ism", $allout, $cookies);
+					if (count($cookies[1]) > 0) {
+						$cookie_data = implode("; ", $cookies[1]);
+					}
+					preg_match_all("/^x-request-id: (.*?)\x0d/ism", $allout, $xheader);
+					$url = $server . $this->_dnsDomain . '/records';
+					curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer {$this->_dnsPass}"));
+					curl_setopt($ch, CURLOPT_URL, $url);
+					curl_setopt($ch, CURLOPT_HEADER, false);
+					$allout=curl_exec($ch);
+
+					$output = json_decode($allout);
+					
+					curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer {$this->_dnsPass}","x-request-id: ".$xheader[1][0]));
+					curl_setopt($ch, CURLOPT_COOKIE, $cookies[1][0]);
+					
 					if (!is_array($output->domain_records)) {
 						$output->domain_records = array();
 					}
-
 					// DO's API lists 20 NS records per page, so additional pages needs to be downloaded
 					// https://redmine.pfsense.org/issues/10952
 					$_domain_records = $output->domain_records;
@@ -1467,11 +1484,20 @@
 						curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
 					}
 					$post_data['type'] = $isv6 ? 'AAAA' : 'A';
-					$post_data['ttl'] = $this->_dnsTTL;
+					$post_data['ttl'] = (integer)$this->_dnsTTL;
 					$post_data['name'] = $this->_dnsHost;
 					$post_data['data'] = $this->_dnsIP;
+					$post_data["priority"] = NULL;
+					$post_data["weight"] = NULL;
+					$post_data["flags"] = NULL;
+					$post_data["tag"] = NULL;
+					curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer {$this->_dnsPass}","x-request-id: ".$xheader[1][0], "Content-Type: application/json"));
+					curl_setopt($ch, CURLOPT_COOKIE, $cookies[1][0]);
 					curl_setopt($ch, CURLOPT_URL, $url);
-					curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
+					curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($post_data));
+
+
+					
 					break;
 				case 'cloudns':
 					/* Uses ClouDNS REST API
